
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>阿里云资源编排服务Python SDK使用入门 / iVAN</title>

    <meta name="description" content="阿里云资源编排服务Python SDK使用入门 阿里云资源编排服务(ROS)为我们维护云计算资源提供了一个低成本.可靠.标准化的方案.基于ROS提供的能力,我们只要编写和维护资源模板文件,就可以达到维护云计算资源的目的,而不再需要花费很多的时间通过控制台来人肉配置.ROS为一些场景下的资源维护提供了不同的思路和可能性,比如很多需要大量临时计算资源的场景,使用ROS将使整个资源申请.应用构建.资源释放过程非常简单. ROS同时提供RESTful API和SDK,这使得我们可以很容易的把ROS对于资源的操作能力集成到我们的应用中.下面我们通过示例">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">阿里云资源编排服务Python SDK使用入门</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p>阿里云资源编排服务（ROS）为我们维护云计算资源提供了一个低成本、可靠、标准化的方案。基于ROS提供的能力，我们只要编写和维护资源模板文件，就可以达到维护云计算资源的目的，而不再需要花费很多的时间通过控制台来人肉配置。ROS为一些场景下的资源维护提供了不同的思路和可能性，比如很多需要大量临时计算资源的场景，使用ROS将使整个资源申请、应用构建、资源释放过程非常简单。</p>
<p>ROS同时提供RESTful API和SDK，这使得我们可以很容易的把ROS对于资源的操作能力集成到我们的应用中。下面我们通过示例介绍一下，如何使用ROS的Python SDK来使用ROS的资源编排功能。</p>
<p><strong><em>注</em></strong>: 示例中的命令行都使用Linux的shell，Windows/DOS用户需要根据情况修改。</p>
<h4>1. 安装Python SDK</h4>
<p>ROS Python SDK依赖Python 2.7以上版本。首先,使用pip安装aliyun-python-sdk-core:</p>
<pre><code>pip install aliyun-python-sdk-core
</code></pre>
<p>aliyun-python-sdk-core是所有阿里云官方Python SDK的公共组件。如果安装过程提示权限错误，可能是因为当前用户没有Python安装路径的写权限，上面的命令可以改成下面这样，后面的例子类似：</p>
<pre><code>sudo pip install aliyun-python-sdk-core
</code></pre>
<p>接下来，安装ROS SDK：</p>
<pre><code>pip install aliyun-python-sdk-ros
</code></pre>
<h4>2. 初始化SDK</h4>
<p>我们首先创建一个文件来存放我们的示例代码:</p>
<pre><code>touch ros_sdk_sample.py
</code></pre>
<p>import必要的库:</p>
<pre><code>from aliyunsdkcore.client import AcsClient
from aliyunsdkros.request.v20150901 import DescribeRegionsRequest, CreateStacksRequest

import json
</code></pre>
<p>初始化SDK客户端对象：</p>
<pre><code>client = AcsClient('你的AccessKeyId', '你的AccessKeySecret', 'cn-beijing')
</code></pre>
<ul>
<li>其中AccessKeyId和AccessKeySecure是用户访问阿里云Open API时的认证信息，可以登陆阿里云官方站后获得: https://ak-console.aliyun.com/</li>
<li>第三个参数是用户访问的资源所在的默认Region，此处为了演示，选择cn-beijing</li>
</ul>
<h4>3. 基本请求过程</h4>
<p>我们通过一个简单的列出Region列表的请求来说明ROS请求的基本过程:</p>
<h5>3.1 构造请求对象</h5>
<p>构造一个表示列出Region列表的请求对象:</p>
<pre><code>req = DescribeRegionsRequest.DescribeRegionsRequest()
</code></pre>
<h5>3.2 发起请求</h5>
<pre><code>status, headers, body = client.get_response(req)
</code></pre>
<ul>
<li>status表示请求的返回状态，与HTTP状态码对应，一般2xx表示成功,4xx和5xx表示出错。</li>
<li>header表示请求的返回头信息，与HTTP头对应</li>
<li>body表示请求的返回内容，与HTTP请求返回的body对应</li>
</ul>
<h5>3.3 处理请求结果</h5>
<p>ROS API返回的内容为JSON格式，所以我们把内容通过JSON反序列化后直接打印到屏幕:</p>
<pre><code>if status == 200:
    regions = json.loads(body)
    print(regions)
else:
    print('Unexpected errors: status=%d, error=%s' % (status, body))

</code></pre>
<p>当请求成功执行时，会在屏幕上打印支持ROS的Region列表，当请求出错时，屏幕上会打印出错的状态代码和出错信息。</p>
<h4>4. 创建资源栈</h4>
<p>接下来，我们用一个更有用的例子来说明如何通过ROS的SDK创建一个包含ECS实例的资源栈。</p>
<h5>4.1 模板</h5>
<p>我们使用下面的模板来创建资源栈:</p>
<pre><code>template = '''

{
    "ROSTemplateFormatVersion": "2015-09-01",
    "Resources": {
        "My_ECS_Instance": {
            "Type": "ALIYUN::ECS::Instance",
            "Description": "Create a ECS instance for demo.",
            "Properties": {
                "ImageId": "m-25qoptbjn",
                "InstanceType": "ecs.s2.large",
                "InternetChargeType": "PayByTraffic",
                "IoOptimized": "none",
                "SystemDisk_Category": "cloud",
                "SecurityGroupId": {
                    "Fn::GetAtt": [
                        "mySecurityGroup",
                        "SecurityGroupId"
                    ]
                }
            }
        },

        "mySecurityGroup": {
            "Type": "ALIYUN::ECS::SecurityGroup",
            "Properties": {
                "SecurityGroupName": "mySecurityGroup"
            }
        }
    }
}

'''
</code></pre>
<p>模板中定义了一个ECS实例和一个安全组，ECS实例使用自定义镜像m-25qoptbjn初始化。</p>
<h5>4.2 构造请求</h5>
<p><strong>创建请求对象</strong></p>
<pre><code>req = CreateStacksRequest.CreateStacksRequest()
</code></pre>
<p><strong>通过HTTP头设置资源栈所在的Region:</strong></p>
<pre><code>req.set_headers({'x-acs-region-id': 'cn-beijing'})
</code></pre>
<p><strong>构造请求的消息体内容:</strong></p>
<pre><code>create_stack_body = '''
{
    "Name": "%s",
    "TimeoutMins": %d,
    "Template": %s
}
''' % ('my_demo_stack', 60, template)
</code></pre>
<ul>
<li>Name是我们将要创建的资源栈的命名，每个用户空间下的资源栈名称不能重复</li>
<li>TimeoutMins是指创建过程如果在指定的时间后不能完成则超时失败，单位分钟</li>
<li>Template表示创建的资源栈使用的模板内容</li>
</ul>
<pre><code>req.set_content(create_stack_body);
</code></pre>
<h5>4.3 提交请求</h5>
<pre><code>status, headers, body = client.get_response(req)
if status == 201:
    result = json.loads(body)
    print(result)
else:
    print('Unexpected errors: status=%d, error=%s' % (status, body))
</code></pre>
<ul>
<li>创建资源栈的请求根据RESTful的习惯使用HTTP POST方式提交，当成功时返回状态为201</li>
</ul>
<h4>5. 资源栈</h4>
<p>当创建资源栈的请求成功时，返回的body中包含被创建资源栈的的ID, Name，如下:</p>
<pre><code>{u'Id': u'61167738-e128-4840-9a37-e568f70aa894', u'Name': u'my_demo_stack'}
</code></pre>
<p>创建资源栈的请求会同步返回，但资源栈内的资源创建是由资源编排服务在后台异步执行的。所以到创建请求返回，并不表示所有资源已经创建完成。我们可以通过ROS的web控制台或者API来查询堆栈的创建状态、创建过程中的事件等等。</p>
<h5>5.1 使用控制台管理资源栈</h5>
<p>登陆ROS控制台(https://ros.console.aliyun.com)  我们可以看到刚刚通过python代码提交创建的资源栈：</p>
<p><a href="https://oss.aliyuncs.com/yqfiles/fd6962ccdc7095291614d71f526d726fdb81f6d8.png" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL29zcy5hbGl5dW5jcy5jb20veXFmaWxlcy9mZDY5NjJjY2RjNzA5NTI5MTYxNGQ3MWY1MjZkNzI2ZmRiODFmNmQ4LnBuZw==.jpg"></a></p>
<p>资源栈的状态为创建中，表示我们的ECS实例还没有创建完成。我们可以查看事件列表来监控资源栈创建过程:</p>
<p><a href="https://oss.aliyuncs.com/yqfiles/20dcff9a6521d7c4d6d82ab45490215c5a8e8dbe.png" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL29zcy5hbGl5dW5jcy5jb20veXFmaWxlcy8yMGRjZmY5YTY1MjFkN2M0ZDZkODJhYjQ1NDkwMjE1YzVhOGU4ZGJlLnBuZw==.jpg"></a></p>
<p>如图所示，ROS首先创建了ECS依赖的安全组，然后创建了ECS实例，ROS会妥善的安排资源间的依赖关系。</p>
<p>最后，资源栈创建完成,我们可以在资源列表中看到所有资源:</p>
<p><a href="https://oss.aliyuncs.com/yqfiles/214a64acbdc0d1cbd1e876df350e0634e4a00e4d.png" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL29zcy5hbGl5dW5jcy5jb20veXFmaWxlcy8yMTRhNjRhY2JkYzBkMWNiZDFlODc2ZGYzNTBlMDYzNGU0YTAwZTRkLnBuZw==.jpg"></a></p>
<h5>5.2 使用SDK管理资源栈</h5>
<p>通过前面对SDK使用的介绍，我们已经熟悉向发送ROS请求和处理返回的细节。同时，ROS的Open API和SDK提供完整的资源栈生命周期管理功能，用户可以通过API和SDK使用ROS提供的所有功能，这些功能包括：</p>
<table>
<thead>
<tr>
<th>Action</th>
<th>说明</th>
</tr>
</thead>
<tbody>
<tr>
<td>AbandonStackRequest</td>
<td>废弃资源栈</td>
</tr>
<tr>
<td>CreateStacksRequest</td>
<td>创建资源栈</td>
</tr>
<tr>
<td>DeleteStackRequest</td>
<td>删除资源栈</td>
</tr>
<tr>
<td>DescribeEventsRequest</td>
<td>查询事件列表</td>
</tr>
<tr>
<td>DescribeRegionsRequest</td>
<td>查询Region列表</td>
</tr>
<tr>
<td>DescribeResourceDetailRequest</td>
<td>查询资源详情</td>
</tr>
<tr>
<td>DescribeResourceTypeDetailRequest</td>
<td>查询资源类型详情</td>
</tr>
<tr>
<td>DescribeResourceTypeTemplateRequest</td>
<td>查询资源模板示例</td>
</tr>
<tr>
<td>DescribeResourceTypesRequest</td>
<td>查询资源类型列表</td>
</tr>
<tr>
<td>DescribeResourcesRequest</td>
<td>查询资源列表</td>
</tr>
<tr>
<td>DescribeStackDetailRequest</td>
<td>查询资源栈详情</td>
</tr>
<tr>
<td>DescribeStacksRequest</td>
<td>查询资源栈列表</td>
</tr>
<tr>
<td>DescribeTemplateRequest</td>
<td>查询模板</td>
</tr>
<tr>
<td>ValidateTemplateRequest</td>
<td>验证模板合法性</td>
</tr>
</tbody>
</table>
<p>ROS的功能还在不断增加中，更详细的说明请关注ROS文档： https://help.aliyun.com/product/9091083_ros.html</p>
<p><strong>本文示例代码可在附件中下载。</strong></p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-28 22:53:51</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/ecs/" title="ECS">ECS</a>, <a href="https://www.iamivan.net/tag/python/" title="python">python</a>, <a href="https://www.iamivan.net/tag/sdk/" title="sdk">sdk</a>, <a href="https://www.iamivan.net/tag/ros/" title="ros">ros</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>阿里云资源编排服务Python SDK使用入门的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MRqeL8b.html" rel="bookmark">阿里云资源编排服务 Java SDK使用入门</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				阿里云资源编排服务 Java SDK使用入门 安装依赖 添加Maven库 &lt;repositories&gt; &lt;repository&gt; &lt;id&gt;sonatype-nexus-staging&lt;/id&gt; &lt;name&gt;Sonatype Nexus Staging&lt;/name&gt; &lt;url&gt;https://oss.sonatype.org/service/local/staging/deploy/maven2/&lt;/url&gt; &			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bKQ2XEp.html" rel="bookmark">通过命令行工具使用阿里云资源编排服务</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				资源编排ROS 是一种简单易用的云计算资源管理和自动化运维服务.用户通过模板描述多个云计算资源的依赖关系.配置等,并自动完成所有资源的创建和配置,以达到自动化部署.运维等目的. 了解更多 通过命令行工具使用阿里云资源编排服务 资源编排服务(ROS)支持用户通过模板文件定义所需的云资源,描述资源间的依赖关系和配置详情,并自动完成资源的创建和配置,以达到自动化部署.运维等目的. 作为一种自动化运维工具,阿里云ROS屏蔽了底层资源操作的复杂性,使得对基础设施资源的管理通过简单的代码就可以实现. 命令行			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/My39B4z.html" rel="bookmark">阿里云资源编排服务正式商业化 基础设施迎来自动化运维时代</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				近日,阿里云资源编排ROS(Resource Orchestration)服务正式商业化,阿里云产品家族再添管理利器. 资源编排服务(以下简称ROS)支持用户通过模板文件定义所需的云资源,描述资源间的依赖关系和配置详情,并自动完成资源的创建和配置,以达到自动化部署.运维等目的. 作为一种自动化运维工具,阿里云ROS屏蔽了底层资源操作的复杂性,使得对基础设施资源的管理通过简单的代码就可以实现. 告别手工运维 DevOps加速普及 云服务的一大优势是能够按需获取IT资源,所以越来越多的用户把应用系统			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pd6QY1b.html" rel="bookmark">轻松使用阿里云资源编排，方便你的API管理</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				11月初,阿里云ROS正式发布API 网关(API Gateway)资源,为云计算用户提供高性能.高可用的 API 托管服务,帮助用户对外开放其部署在 ECS.容器服务等阿里云产品上的应用,提供完整的 API 发布.管理.维护生命周期管理.用户只需进行简单的操作,即可快速.低成本.低风险地开放数据或服务. 用户只需要按照自己的需求,根据ROS的模板规范,定义自己的API管理模板,就可以轻轻松松实现API组的创建/更新,API的创建/更新,API的发布或者版本切换,以及API授权,签名,流控等等的			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pkGRr7p.html" rel="bookmark">告别繁荣缛节，阿里云资源编排支持API网关</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				阿里云ROS的API 网关资源11月初正式上线,资源编排(ROS) 支持在模板中定义API 网关资源,助力用户快速.便捷管理发布自己的API.目前,阿里云ROS 产品免费提供给广大用户. 资源编排服务 (Resource Orchestration Service 简称 ROS) 是一款帮助阿里云用户简化云计算资源管理和自动化运维的服务.用户遵循 ROS 定义的模板规范,编写模板文件,在模板中定义所需云计算资源的集合及资源间的依赖关系.资源配置细节等,ROS 通过编排引擎自动完成所有资源的创建和			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M9x1Z3b.html" rel="bookmark">使用阿里云开放搜索服务快速搭建资源搜索网站</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				大家好,我又来了,答应云栖论坛一周一篇文章, 由于工作太忙已中断1个多月实在抱歉,这一次写点轻松有趣的东西-快速的做个资源搜索站 依稀记得十来年前,带宽还只有2M的时候,受各个论坛启发,做了可以搜索嘿嘿嘿资源的搜索站 一晃这么多年过去,嘿嘿嘿的东西依然喜欢,但世间却变化万千 资源种类已不仅仅是X片,高清电影.纪录片.无损音乐.美剧.大型软件等等,似乎更加吸引 资源呈现方式也百花齐放,从最早的BT文件.电驴地址,到现在的磁链地址.各种云盘等等 而传统的P2P下载方式也变得格格不入,因为硬盘容量已经			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/xp8NnPb.html" rel="bookmark">日志服务使用Python SDK快速入门指南</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				为快速开始使用日志服务Python SDK,请按照如下步骤进行: 创建阿里云账号 为了访问阿里云日志服务,你需要有一个阿里云账号.如果没有,可首先如下创建阿里云账号: 访问阿里云官方网站,点击页面上&quot;注册&quot;按钮. 按照屏幕提示完成注册流程并进行实名认证. 为了更好地使用阿里云服务,建议尽快完成实名认证,否则部分阿里云服务将无法使用.具体实名认证流程请参考这里 获取阿里云访问秘钥 为了使用SDK,你必须申请阿里云的访问秘钥: 登陆阿里云管理控制台. 访问阿里云秘钥管理页面. 选择一对用于			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/b3oG60b.html" rel="bookmark">如何接入阿里云短信服务 （完整指南）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				目录 一.注册并实名认证 二.开通短信服务 三.获取AccessKey 四.设置短信内容 五.配置短信接口 六.发送短信 七.常见问题FAQ 一.注册并实名认证 使用阿里云短信服务,用户需要先在阿里云注册,并完成个人/企业实名认证. 注意:要发送营销短信的用户,必须完成企业实名认证 1.1 注册阿里云:点此注册  1.2 实名认证:点此认证  1.3 绑定企业支付宝: 点击绑定企业支付宝   二.开通短信服务 2.1.开通短信服务:点击开通短信服务 2.2 子账号页面:点击查看子账号页面 2.3			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MRDdnBz.html" rel="bookmark">利用资源编排服务，创建安全组&lpar;SecurityGroup&rpar;访问规则</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				前面我们介绍了各种姿势创建ECS实例,例如:一键创建包年包月ECS实例, 通过资源编排创建一个ECS实例.本文详细介绍一下安全组(SecurityGroup). 资源简介 ROS 分别提供三种资源 ALIYUN::ECS::SecurityGroup, ALIYUN::ECS::SecurityGroupEgress 和ALIYUN::ECS::SecurityGroupIngress, 创建安全组和出入访问规则. 其中,ALIYUN::ECS::SecurityGroup 可以同时配置访问规则			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/0zG3ZEz.html" rel="bookmark" class="title">将PPT列表文字变图形的三种方法</a>
					<div>
						  有时候,我们需要将PPT中的文字变成图形的形式,通常我们会以点符列表来进行格式化.现在,对于这些昔日的作品与文件,您只要通过PowerPoint 2007 全新的自动化转换工具就能轻松完成了. 您 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/9Mxjl0z.html" rel="bookmark" class="title">eclipse javascript&colon; 解决eclipse中Errors running builder JavaScript Validator的问题</a>
					<div>
						解决eclipse中Errors running builder JavaScript Validator的问题具体错误信息:Errors occurred during the build. Err ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/2MW5Nmz.html" rel="bookmark" class="title">调用winrar压缩文件夹</a>
					<div>
						winrar|压缩|winrar|压缩 服务器用WScript.Shell组件调用winrar中的rar.exe,在代码的同目录要上传cmd.exe和rar.exe 用法:rar.asp?path=要 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/XpmnE3z.html" rel="bookmark" class="title">今天看到一个很好的类-操作xml的！贴出来给大家，不知道以前贴过没有？</a>
					<div>
						xml &lt;?/*     (c) 2000 Hans Anderson Corporation.  All Rights Reserved.     You are free to use an ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/xp8ll9p.html" rel="bookmark" class="title">判断的条件是一个字符串的长度</a>
					<div>
						条件|字符串 2004-10-810:49:42青 好好利用时间(f)wingc@SQL也不简单啊吴聪,请教一下sql中,如果判断的条件是一个字符串的长度,比如column1字段的长度是3,如&quo ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/dzZljOM.html" rel="bookmark" class="title">浅谈站长如何挖掘符合用户搜索的关键词</a>
					<div>
						站长每天都要围着用户体验转,毕竟用户体验是否良好则是决定网站能否生存下去的关键因素.只有网站拥有了良好的用户体验,才能谈关于网站发展的.网站赚钱的方向.而对于网站来说,关键词则是网站建设的第一步,正所 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M1R69ap.html" rel="bookmark" class="title">Oracle中如何验证catalog的恢复功能</a>
					<div>
						1.建立catalog库,并注册target database和同步catalog db --建立数据库的备份 [oracle@rh4 ~]$ rman target / catalog rman/r ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlRdYqz.html" rel="bookmark" class="title">《Programming WPF》翻译 第4章 4&period;数据源</a>
					<div>
						目前为止,我们已经简单的处理了对象.然而,这并不是数据的唯一来源: XML和突然想到的相关数据库,都是流行的选择.更进一步地,由于XML或 相关数据库并不能存储数据为.NET对象,某些转换可能需要支持 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M1RdG8p.html" rel="bookmark" class="title">Photoshop合成房屋悬浮场景</a>
					<div>
						ps教程Photoshop合成房屋悬浮场景   本教程主要使用Photoshop合成被巫师作法悬浮的房屋场景教程,除了令人毛骨悚然的悬浮房屋,你会掌握如何创建一些非常酷的3D风格的字体效果,如何有效地 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M9170gM.html" rel="bookmark" class="title">MySQL数据导入到SQLite工具</a>
					<div>
						将MySQL数据导入到SQLite数据库中,可是MySQL导出的sql文件又不能直接导入到SQLite,自己又懒得写代码, 于是上网搜了一下,还真有这样一个工具可以实现 CYQ.DBImort 下载地 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p8jK43b.html" rel="bookmark" class="title">搜狗输入法2015状态栏不见了怎么办</a>
					<div>
						  搜狗输入法状态栏显示最佳方法 法一.在搜狗输入法&quot;设置属性&quot;中检查一下&quot;常用&quot;--&quot;初始状态&quot;中的&quot;隐藏状态栏&quot;是否 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pLOx0LM.html" rel="bookmark" class="title">WPS2016怎么设置自动保存</a>
					<div>
						WPS演示设置自动保存时间的方法: ①启动WPS演示,单击左上角的按钮,点击选项按钮. ②切换到常规和保存选项卡. ③勾选定时备份,设置保存时间间隔.我们还可以设置保存文件的路径. ④设置好了之后,到 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p8ZZyob.html" rel="bookmark" class="title">如何在Windows 8中对未分配的磁盘空间进行分区</a>
					<div>
						  1.系统下同时按住键盘上 &quot; Windows &quot; 和 &quot;X&quot; 键打开系统菜单 ,选择&quot;磁盘管理&quot;; 2.能够看到未分配的空间,对准这部分 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mr3dX6p.html" rel="bookmark" class="title">如何在Excel2010单元格显示图表</a>
					<div>
						  往往我们用到的Excel插入图表时,图表都会占据很多个单元格,有没有什么办法能够让图表只在一个单元格中显示呢?其实方法是有的,目前最新版本的Excel2010就有这项功能,叫&quot;迷你图表& ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M9EZjKM.html" rel="bookmark" class="title">求解最长递增子序列长度&vert;动态规划&plus;二分查找&colon;C&bsol;C&plus;&plus;实现</a>
					<div>
						01 /* 求解最长递增子序列长度 */ 02 #include &lt;iostream&gt; 03 #include &lt;limits&gt; 04   05 using namespace ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z42Q0NM.html" rel="bookmark" class="title">QQ外挂扰攘腾讯著作权</a>
					<div>
						中介交易 http://www.aliyun.com/zixun/aggregation/6858.html&quot;&gt;SEO诊断 淘宝客 云主机 技术大厅 近日,腾讯QQ与51.com之间因 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pn7n6Kz.html" rel="bookmark" class="title">如何正确设置和输入版权所有处的版权符号</a>
					<div>
						中介交易 http://www.aliyun.com/zixun/aggregation/6858.html&quot;&gt;SEO诊断 淘宝客 云主机 技术大厅 在制作网站时,经常会在自己的网站的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5ZXo6z.html" rel="bookmark" class="title">Java的国际化支持（I18N问题）</a>
					<div>
						一,读取PC的locale信息 Locale信息是由语言跟国家代码组成的,在Java中,提供了Locale类对应语言信息. /* * //获取local信息 Locale defaultLocale  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bKYPqZp.html" rel="bookmark" class="title">郑学勤：美元回升具有世界性影响</a>
					<div>
						4月16日晚间消息 芝加哥期权交易所董事总经理郑学勤对新浪财经表示,由于美元是世界性的货币,如果美国加息后美元回升,不仅仅会影响美国经济,也会影响到其他地区依靠便宜货币来运作的大宗商品买卖,此外,对全 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zJAWvwp.html" rel="bookmark" class="title">指针-DirectDraw Blt切图数据有错</a>
					<div>
						问题描述 DirectDraw Blt切图数据有错 LPDIRECTDRAWSURFACE7 lpDDSPrimary; // DDSCAPS_PRIMARYSURFACE主页面的指针 LPDIREC ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MqR6A2p.html" rel="bookmark" class="title">神码ERP为裕同经营管理应用案例</a>
					<div>
						印刷包装行业竞争早已进入白热化,很多企业已是举步维艰,而王华君创办的深圳市裕同印刷公司却发展迅猛.脱颖而出,短短9年间就发展到拥有3000多员工.年产值4亿元.其发展的关键因素是什么呢?信息化又在其中 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MRNwmaM.html" rel="bookmark" class="title">新手学struts2求帮忙啊</a>
					<div>
						问题描述 struts配置文件加上&lt;constantname=&quot;struts.devMode&quot;value=&quot;true&quot;/&gt;这句话启动服务器就报错啊. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mvn44WM.html" rel="bookmark" class="title">winform excel-winform下导入Mhtml类型的excel</a>
					<div>
						问题描述 winform下导入Mhtml类型的excel winform下导入Mhtml类型的excel,该文件用excel直接可以打开,请问,我在程序中怎么读取这个数据集?正常的oledb我试了,办 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvnOR1M.html" rel="bookmark" class="title">异常：Cannot narrow remote object to com&period;dc&period;eai&period;ejb&period;ServiceHome</a>
					<div>
						问题描述 源码:packagexx.xx;importjava.util.Properties;importjavax.naming.Context;importjavax.naming.Initia ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bBgqjJM.html" rel="bookmark" class="title">arm64 v8a arm64 v7a-jar包与arm64-v8a、arm64-v7a文件夹下的so</a>
					<div>
						问题描述 jar包与arm64-v8a.arm64-v7a文件夹下的so track代码发现引用的是stidcard.jar包里的,而且程序中并没有引用arm64-v8a或者arm64-v7a文件夹下 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bBkP6KM.html" rel="bookmark" class="title">vue&period;js通过自定义指令实现数据拉取更新的实现方法&lowbar;javascript技巧</a>
					<div>
						前言 这篇文章的代码片段位于 vue 的单文件组件中,即以 .vue 结尾的文件中,本文说明的只是一种实现方法,既不是唯一的方法也不是最好的方法,如果大家有更好的方法可以留言,大家进行讨论. 第一步  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvYlaWb.html" rel="bookmark" class="title">PHP mkdir&lpar;&rpar;无写权限的问题解决方法&lowbar;php实例</a>
					<div>
						使用mkdir创建文件夹时,发现这个函数有两个参数,第二个参数是为新创建的文件夹指定权限. 但是如果直接用mkdir('文件地址', 0777);时 发现新文件夹的权限并不是777,一般情况下会是02 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pn8BrAb.html" rel="bookmark" class="title">多线程-求解为什么sem&lowbar;init会deprecated</a>
					<div>
						问题描述 求解为什么sem_init会deprecated 解决方案 解决方案二: 我知道了 呵呵 CSDN没人理我吗.. 我觉得这个问题还是worth answering啊,我知道可以google到 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvWnBrp.html" rel="bookmark" class="title">OpenStack是否会像Linux一样缔造传奇</a>
					<div>
						问题描述 OpenStack是一个由Rackspace发起.全球开发者共同参与的开源项目,旨在打造易于部署.功能丰富且易于扩展的云计算平台.OpenStack企图成为数据中心的操作系统,即云操作系统. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zDXQn6z.html" rel="bookmark" class="title">tplink路由器多WAN口路由器是否可以叠加带宽？</a>
					<div>
						一.为什么要有多WAN口? 路由器连接多条宽带的目的主要有以下三个: 增加带宽:上网主机可以通过任意宽带上网,从应用角度讲,相当于一条更高速的带宽. 冗余备份:如果其中一条宽带出现故障,可以使用其他宽 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 12 q. 0.033 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
